#include <windows.h>
#include <windowsx.h>
#include <gdiplus.h>
#include <tchar.h>

using namespace Gdiplus;

class ImageWindow{
	BITMAPINFOHEADER bmih;
	BYTE *pBits;
	HBITMAP hBitmap,HOldBitmap;
	HDC hdcBMP;
	HWND hWnd;
	int dx,dy;
	int ix,iy;
	int wx,wy;
	double scale;
	SCROLLINFO hsi,vsi;
public:
	ImageWindow(){
		dx=dy=ix=iy=wx=wy=0;
		scale=1.0;
	}
	int GetCurrentPositionX(void){
		return dx;
	}
	int GetCurrentPositionY(void){
		return dy;
	}
	void ClearPos(void){
		dx=dy=0;
		scale=1.0;

	}
	void wm_size(int x,int y){
		wx=x;
		wy=y;
		if(ix*scale < wx){	//	EBhEɎ܂Ăꍇ̓EBhE̐^񒆂ɕ\
			dx=int((double(wx) - double(ix)*scale ) /2);
		}
		if(iy*scale < wy){	//	EBhEɎ܂Ăꍇ̓EBhE̐^񒆂ɕ\
			dy=int((double(wy) - double(iy)*scale ) /2);
		}
	}
	void SetHWND(HWND h){
		hWnd=h;
	}
	bool LoadImage(TCHAR* fname,HDC hdc){
		Image* imageP;
#ifndef UNICODE
		WCHAR wTitle[MAX_PATH];
		MultiByteToWideChar(932,0,szFile,-1,wTitle,sizeof(wTitle)/sizeof(TCHAR));
		imageP=Bitmap::FromFile(wTitle);
#else
		imageP=new Image(fname);
#endif
		if(imageP==0){
			ix=0;
			iy=0;
			hdcBMP=0;
			return false;
		}
		bmih.biSize=sizeof(bmih);
		bmih.biWidth=ix=imageP->GetWidth();
		bmih.biHeight=iy=imageP->GetHeight();
		bmih.biPlanes=1;
		bmih.biBitCount=32;
		bmih.biCompression=BI_RGB;
		bmih.biSizeImage=0;
		bmih.biXPelsPerMeter=0;
		bmih.biYPelsPerMeter=0;
		bmih.biClrUsed=0;
		bmih.biClrImportant=0;
		hBitmap=CreateDIBSection(NULL,(BITMAPINFO*)&bmih,0,(void**)&pBits,NULL,0);
		if(pBits==NULL){
			MessageBox(0,_TEXT("sĂ܂B"),_TEXT("Message"),MB_YESNO | MB_ICONQUESTION);
			DeleteObject(hBitmap);
			delete imageP;
			ix=0;
			iy=0;
			return false;
		}
		hdcBMP=CreateCompatibleDC(hdc);
		HOldBitmap=(HBITMAP)SelectObject(hdcBMP,hBitmap);
		Graphics* MyGraphics=new Gdiplus::Graphics(hdcBMP);
		MyGraphics->DrawImage(imageP,0,0,ix,iy);
		delete imageP;
		delete MyGraphics;
		return true;
	}

	void DelImage(void){
		if(hdcBMP){
			SelectObject(hdcBMP,HOldBitmap);
			DeleteObject(hBitmap);
			DeleteDC(hdcBMP);
		}
	}
	bool IsImage(void){
		if(hdcBMP)
			return true;
		else
			return false;
	}
	void ScrollBarDraw(void){
		hsi.cbSize=sizeof(SCROLLINFO);
		hsi.fMask= SIF_POS | SIF_RANGE | SIF_PAGE;
		hsi.nMin=0;
		hsi.nMax=int(double(ix)*scale-1);
		hsi.nPage=wx;
		hsi.nPos=-dx;
		SetScrollInfo(hWnd,SB_HORZ,&hsi,TRUE);

		vsi.cbSize=sizeof(SCROLLINFO);
		vsi.fMask= SIF_POS | SIF_RANGE | SIF_PAGE;
		vsi.nMin=0;
		vsi.nMax=int(double(iy)*scale-1);
		vsi.nPage=wy;
		vsi.nPos=-dy;
		SetScrollInfo(hWnd,SB_VERT,&vsi,TRUE);
	}
	void JustSize(void){
		int sx,sy;
		double pxy=double(ix)/double(iy);	// IWi/c
		double dxy=double(wx)/double(wy);	// ϊ㉡/c
		int dx2,dy2;
		if(pxy>dxy){	//	IWîŉɏck
			dx2=wx;
			dy2=(int)double(wx/pxy);
		}else{
			dy2=wy;
			dx2=(int)double(wy*pxy);
		}
		sx=dx2;
		sy=dy2;
		scale=double(sx)/double(ix);
		dx=(wx-sx)/2;
		dy=(wy-sy)/2;
		ScrollBarDraw();
	}
	void wm_hscroll(WPARAM wp,LPARAM lp){
		int rdx;
		int ddx=GetCurrentPositionX();
		rdx=ddx;
		switch(LOWORD(wp)){
		case SB_LINEUP:
			++ddx;
			break;
		case SB_LINEDOWN:
			--ddx;
			break;
		case SB_PAGEUP:
			ddx+=hsi.nPage;
			break;
		case SB_PAGEDOWN:
			ddx-=hsi.nPage;
			break;
		case SB_THUMBTRACK:
			ddx=-HIWORD(wp);
			break;
		}
		if(rdx != ddx){
			if(0<ddx)
				ddx=0;
			else{
				if(ddx< ((int)hsi.nPage-hsi.nMax) )
					ddx=(int)hsi.nPage-hsi.nMax;
			}
			dx=ddx;
			hsi.nPos=-ddx;
			ScrollBarDraw();
			ScrollWindow(hWnd, ddx-rdx, 0,NULL, NULL);
		}
	}
	void wm_vscroll(WPARAM wp,LPARAM lp){
		int rdy;
		int ddy=GetCurrentPositionY();
		rdy=ddy;
		switch(LOWORD(wp)){
		case SB_LINEUP:
			++ddy;
			break;
		case SB_LINEDOWN:
			--ddy;
			break;
		case SB_PAGEUP:
			ddy+=vsi.nPage;
			break;
		case SB_PAGEDOWN:
			ddy-=vsi.nPage;
			break;
		case SB_THUMBTRACK:
			ddy=-HIWORD(wp);
			break;
		}
		if(0<ddy)
			ddy=0;
		else{
			if(ddy< ((int)vsi.nPage-vsi.nMax) )
				ddy=(int)vsi.nPage-vsi.nMax;
		}
		if(rdy != ddy){
			dy=ddy;
			vsi.nPos=-ddy;
			ScrollBarDraw();
			ScrollWindow(hWnd, 0, ddy-rdy, NULL, NULL);
		}
	}

	bool wm_mousewheel(int m_x,int m_y,int m_delta){	//	gk
		double rscale=scale;
		if(m_delta<0)
			scale/=2;
		else
			scale*=2;

		int isx;
		int isy;
		isx=int(double(ix)*scale);
		isy=int(double(iy)*scale);
		if(isx>64 && isy>64){
			int rdx=dx;
			int rdy=dy;
			dx=int(m_x-double(m_x-dx)/rscale*scale);
			dy=int(m_y-double(m_y-dy)/rscale*scale);
			ScrollBarDraw();
			return true;
		}else
			scale=rscale;
		return false;
	}
	void MoveImage(int m_x,int m_y,int cx,int cy){
		int rdx=dx;
		int rdy=dy;
		dx=m_x-cx;	//	ړ
		dy=m_y-cy;	//	ړ
		if(wx < ix*scale){	//	EBhETCY\TCY傫ꍇ
			if( ix*scale+dx < wx)	//	E[ɒBĂꍇ
				dx=int(wx-double(ix)*scale);
			if(0<dx)	//	[ɒBĂꍇ
				dx=0;

		}else{	//	EBhETCYɕ\TCY܂Ăꍇ
			dx=rdx;
		}

		if(wy < iy*scale){	//	EBhETCY\TCY傫ꍇ
			if( iy*scale+dy < wy)	//	[ɒBĂꍇ
				dy=int(wy-double(iy)*scale);
			if(0<dy)	//	[ɒBĂꍇ
				dy=0;
		}else{	//	EBhETCYɕ\TCY܂Ăꍇ
			dy=rdy;
		}

		if(rdx!=dx || rdy!=dy){
			ScrollWindow(hWnd, dx-rdx,dy-rdy ,NULL, NULL);
			ScrollBarDraw();
		}
	}
	void wm_paint(HDC hdc){
		StretchBlt(hdc,dx,dy,int((double)ix*scale),int((double)iy*scale),hdcBMP,0,0,ix,iy,SRCCOPY);
	}
};
